
(define bozo
  (list (list 2 2 4 2 #t)
	(list 4 2 6 2 #t)
	(list 6 2 8 2 #t)
	(list 6 4 6 2 #t)
	))


;; simulation:

;; phase 1:
;; if y1 = y2 place val in vert_valu[x2,y2], place 1 in vert_want[x1,y1]
;;                    1 in vert_have[x2,y2]
;; else       place val in horz_valu[x2,y2], place 1 in horz_want[x1,y1]
;;                    1 in horz_have[x2,y2]

;; phase 2:
;;   vert_block[x1,y1] = vert_valu[x1,y1] unless vert_want[x1,y1])
;;   horz_block[x1,y1] = horz_valu[x1,y1] unless horz_want[x1,y1])

;; phase 4:
;; if y1 = y2
;;   if vert_have[x1,y1], get 
;;      vert_valu[x1,y1] unless horz_block[x1,y1]
;;   else
;;      horz_valu[x1,y1]
;; else
;; ....


(define makem
  (lambda (w h)
    (make-initialized-vector w (lambda (x) (make-vector h #f)))))

(define setm
  (lambda (matrix x y v)
    (vector-set! (vector-ref matrix x) y v)))

(define getm
  (lambda (matrix x y)
    (vector-ref (vector-ref matrix x) y)))

(define phase1
  (lambda (state v-want v-have v-valu h-want h-have h-valu)
    (map 
     (lambda (x)
       (let ((x1 (car x))
	     (y1 (cadr x))
	     (x2 (caddr x))
	     (y2 (cadddr x))
	     (v (car (cdr (cdddr x)))))
	 (if (= x1 x2)
	     (begin
	       (setm v-valu x2 y2 v)
	       (setm v-have x2 y2 #t)
	       (setm v-want x1 y1 #t))
	     (begin
	       (setm h-valu x2 y2 v)
	       (setm h-have x2 y2 #t)
	       (setm h-want x1 y1 #t)))))
     state)))

(define phase2
  (lambda (state v-want v-have v-valu h-want h-have h-valu)
    (map 
     (lambda (x)
       (let ((x1 (car x))
	     (y1 (cadr x))
	     (x2 (caddr x))
	     (y2 (cadddr x))
	     (v (car (cdr (cdddr x)))))
	 (let ((nv
		(if (= x1 x2)
		    (if (getm v-have x1 y1)
			(and (getm v-valu x1 y1)
			     (not (and (getm h-valu x1 y1)
				       (not (getm h-want x1 y1)))))
			(getm h-valu x1 y1))
		    (if (getm h-have x1 y1)
			(and (getm h-valu x1 y1)
			     (not (and (getm v-valu x1 y1)
				       (not (getm v-want x1 y1)))))
			(getm v-valu x1 y1)))))
	   (list x1 y1 x2 y2 nv))))
     state)))

;; phase 2:
;;   vert_block[x1,y1] = vert_valu[x1,y1] unless vert_want[x1,y1])
;;   horz_block[x1,y1] = horz_valu[x1,y1] unless horz_want[x1,y1])

;; phase 4:
;; if y1 = y2
;;   if vert_have[x1,y1], get 
;;      vert_valu[x1,y1] unless horz_block[x1,y1]
;;   else
;;      horz_valu[x1,y1]
;; else
;; ....



(define makem-norm
  (lambda (x)
    (makem 10 10)))

(define my-v-want (makem-norm 0))
(define my-v-have (makem-norm 0))
(define my-v-valu (makem-norm 0))
(define my-h-want (makem-norm 0))
(define my-h-have (makem-norm 0))
(define my-h-valu (makem-norm 0))




(define mym (makem 5 10))

(getm mym 4 3)
(setm mym 4 3 2)
(getm mym 4 3)


(define sim
  (lambda (steps circuit)
    (let ((my-v-want (makem-norm 0))
	  (my-v-have (makem-norm 0))
	  (my-v-valu (makem-norm 0))
	  (my-h-want (makem-norm 0))
	  (my-h-have (makem-norm 0))
	  (my-h-valu (makem-norm 0)))
      (if (> steps 0)
	  (begin
	    (phase1 circuit
		    my-v-want my-v-have my-v-valu 
		    my-h-want my-h-have my-h-valu)
	    (sim (- steps 1)
		 (phase2 circuit
			 my-v-want my-v-have my-v-valu 
			 my-h-want my-h-have my-h-valu)))
	  circuit))))
	  


(begin
  (phase1 bozo 
	  my-v-want my-v-have my-v-valu 
	  my-h-want my-h-have my-h-valu)
  (phase2 bozo 
	  my-v-want my-v-have my-v-valu 
	  my-h-want my-h-have my-h-valu)
)

(sim 3 bozo)


      
(if #f 1 2)
