#!/usr/bin/perl -w

use strict;

use GD;
use CGI qw/:standard/;

#if ($#ARGV<0) {
#    print STDERR "Need a number -- arguments are: number [open] [close]\n";
#    exit(1);
#}
#my $num = $ARGV[0];
my $num = 0;
my $open = 0;
my $close = 0;
my $has_num = 0;
#if ($#ARGV>=1) {
#    $open = $ARGV[1];
#}
#if ($#ARGV>=2) {
#    $close = $ARGV[2];
#}
if (defined(param('n'))) {
    $num = param('n');
}
if (defined(param('o'))) {
    $open = param('o');
}
if (defined(param('o'))) {
    $close = param('c');
}
if (defined(param('h'))) {
    $has_num = param('h');
}
my $webby = 1;
if (defined(param('cmd'))) {
    $webby = 0;
}

my $w = 16;
my $h = 16;

my $im = new GD::Image($w,$h);

my $white = $im->colorAllocate(255,255,255);
my $black = $im->colorAllocate(0,0,0);       
my $red = $im->colorAllocate(255,0,0);      
my $blue = $im->colorAllocate(0,0,255);
my $gray = $im->colorAllocate(200,200,200);

my $color = $blue;

sub ShowMid {
    my $dx = shift;
    my $dy = shift;
    my $s = $w*0.75*0.5;
    $im->line($w/2+$s*$dx,$h/2+$s*$dy,
	      $w/2-$s*$dx,$h/2-$s*$dy,
	      $gray);
}

sub ShowEdge {
    my $dx = shift;
    my $dy = shift;
    my $s = $w*0.75*0.5;
    $im->line($w/2+$s*$dx+$s*$dy,$h/2+$s*$dy-$s*$dx,
	      $w/2+$s*$dx-$s*$dy,$h/2+$s*$dy+$s*$dx,
	      $blue);
}

sub ShowCorner {
    my $dx = shift;
    my $dy = shift;
    my $dir = shift;
    my $s = $w*0.75*0.5*0.5;
    if ($dir) {
	$im->line($w/2,$h/2,
		  $w/2+$s*2*$dx,$h/2+$s*2*$dy,
		  $blue);
    } else {
	$im->line($w/2+$s*$dx+$s*$dy,$h/2+$s*$dy-$s*$dx,
		  $w/2+$s*$dx-$s*$dy,$h/2+$s*$dy+$s*$dx,
		  $blue);
    }
}

sub ShowPart {
    my $id = shift;
    if ($id==0) {
	ShowEdge(0,-1);
    } elsif ($id==1) {
	ShowEdge(-1,0);
    } elsif ($id==2) {
	ShowEdge(0,1);
    } elsif ($id==3) {
	ShowEdge(1,0);
    } elsif ($id==4) {
	ShowCorner(-1,-1,1);
    } elsif ($id==5) {
	ShowCorner(-1,+1,1);
    } elsif ($id==6) {
	ShowCorner(+1,+1,1);
    } elsif ($id==7) {
	ShowCorner(+1,-1,1);
    } else {
	exit(1);
    }
}

# make the background transparent and interlaced
#$im->transparent($white);
#$im->interlaced('true');

$im->rectangle(0,0,$w-1,$h-1,$white);

my $all = 0;

#if (!($open||$close)) {
#}

if ($has_num) {
    ShowMid(0,1);
    ShowMid(1,0);    
}

if ($open) {
    ShowMid(1,0);
    ShowCorner(-1,-1,0);
    ShowCorner(-1,+1,0);
}

if ($close) {
    ShowMid(1,0);
    ShowCorner(+1,-1,0);
    ShowCorner(+1,+1,0);
}

if ($num>0) {
    my $n = $num;
    for (my $i=0; $i<8; $i++) {
	if ($n%2!=0) {
	    ShowPart($i);
	    #print STDERR "$i\n";
	}
	$n = ($n-$n%2)/2;
    }
}

if ($all) {
    ShowMid(1,0);
    ShowMid(0,1);
    ShowEdge(-1,0);
    ShowEdge(1,0);
    ShowEdge(0,1);
    ShowEdge(0,-1);
    ShowCorner(-1,-1,0);
    ShowCorner(-1,+1,0);
    ShowCorner(+1,-1,0);
    ShowCorner(+1,+1,0);
    ShowCorner(-1,-1,1);
    ShowCorner(-1,+1,1);
    ShowCorner(+1,-1,1);
    ShowCorner(+1,+1,1);
}


if ($webby) {
    printf("Content-type: image/png%c",10);
    printf("Content-length: %d%c%c", length($im->png),10,10);
    print $im->png;
} else {
# make sure we are writing to a binary stream
    binmode STDOUT;
# Convert the image to PNG and print it on standard output
    print $im->png;
}
    


