#!/usr/bin/perl -w

use strict;

use PostScript::Simple;


my    $p = new PostScript::Simple(papersize => "A4",
                                colour => 1,
                                eps => 0,
                                units => "in");

my $s = 0.25;

while (<>) {
    if ($_ =~ /([\-0-9]+) ([\-0-9]+) ([\-0-9]+) ([\-0-9]+)( ([\-0-9]+))?/) {
	my $xmid = $1;
	my $ymid = $2;
	my $dx = $3;
	my $dy = $4;
	my $v = $6 || 0;
	#print ">>> $xmid $ymid $dx $dy\n";
	if ($v) {
	    $p->setcolour(255,0,0);
	}
	$p->polygon(($xmid-$dx)*$s,($ymid-$dy)*$s, 
		    ($xmid+$dx)*$s,($ymid+$dy)*$s);
	my $xon = ($dx)*0.2;
	my $yon = ($dy)*0.2;
	my $xoff = $yon;
	my $yoff = $xon;
	$p->polygon(($xmid+$xoff)*$s,($ymid+$yoff)*$s, 
		    ($xmid+$xon)*$s,($ymid+$yon)*$s, 
		    ($xmid-$xoff)*$s,($ymid-$yoff)*$s);
	if ($v) {
	    $p->setcolour(0,0,0);
	}
    }
}

#$p->output("file.ps");

print $p->get();



