
package unless;

import javax.swing.*;        
import java.awt.*;
import java.awt.event.*;


/** Draw on this JPanel rather than on the JApplet. **/
public class UnlessPane extends JPanel {

  UnlessPane () {
    // Set background color for the applet's panel.
    setBackground (Color.WHITE);
  } // ctor

  public void paintComponent(Graphics g)   {
   // Paint background
   super.paintComponent(g);

   // Get the drawing area
   int dY = getSize ().height;
   int dX = getSize ().width;
   int midX = dX/2;
   int midY = dY/2;
   int rectX = 3 * dX/4;
   int rectY = 3 * dY/4;

   // Set current drawing color
   g.setColor (Color.BLACK);

   // Draw a rectangle centered at the mid-point
   g.drawRect (midX-rectX/2, midY-rectY/2,
               rectX, rectY );

   // Set a new drawing color
   g.setColor (Color.LIGHT_GRAY);

   // Fill a rectangle centered at the mid-point. Put it
   // within the previous rectangle so that border shows.
   g.fillRect (midX-rectX/2+10, midY-rectY/2 +10,
              rectX-20, rectY-20);

   /*
   float s = 0.25;
   
        $s = 0.25;
	$p->polygon(($xmid-$dx)*$s,($ymid-$dy)*$s, 
	            ($xmid+$dx)*$s,($ymid+$dy)*$s);
	my $xon = ($dx)*0.2;
	my $yon = ($dy)*0.2;
	my $xoff = $yon;
	my $yoff = $xon;
	$p->polygon(($xmid+$xoff)*$s,($ymid+$yoff)*$s, 
		    ($xmid+$xon)*$s,($ymid+$yon)*$s, 
		    ($xmid-$xoff)*$s,($ymid-$yoff)*$s);
*/

   // Set a new drawing color
   g.setColor (Color.DARK_GRAY);

   // Draw a circle around the mid-point
   g.drawOval (midX-rectX/6, midY-rectX/6,
               rectX/3, rectX/3);

   // Fill a concentric circle inside the previous one
   g.drawOval (midX-rectX/6+10,midY-rectX/6+10,
               rectX/3-20,rectY/3-20);

   for (int x=0; x<100; x+=10) {
       g.drawLine(x,0,x,100);
       g.drawLine(0,x,100,x);
   }


  } // paintComponent
} // class DrawingPanel
